C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MACCES                                                  +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE ACCES.                         +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINE                    ACCES                                 +
C       -  DOUBLE PRECISION FUNCTIONS    DAQES, IASSER                         +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PROGRAM MACCES
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      INTEGER INIT, N, M
      DOUBLE PRECISION A, B, R
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (MAXDIM = 25)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      DOUBLE PRECISION SN(-1:MAXDIM), TN(-1:MAXDIM), DN(0:MAXDIM), 
     *          UN(0:MAXDIM)
C
C                        ... EXECUTABLE STATEMENTS
C
      WRITE (*,*) ' OUTPUT RESULTS FROM MACCES'
      WRITE (*,*)
      A = 1.0D0
      B = 2.0D0
      M = 25
      WRITE (*,100) A, B, M
      IF (M .GT. MAXDIM) M = MAXDIM
C
C                        ... SN(N) CONTAINS 
C                                   -1
C                        S   = (N+1)  * SIN A*(N+1) (N =0, 1, 2, ...)
C                         N+1
C
      DO 10 N = 0, M
         SN(N) = DSIN(A*(N+1)) / (N+1)
         DN(N) = B * (SN(N)**2- SN(N))
   10 CONTINUE
C
      INIT = 0
      DO 20 N = 0, M
         CALL ACCES (SN, DN, TN, UN, R, INIT)
	 WRITE (*,200) N, SN(N), R, UN(N), UN(N)/SN(N)
   20 CONTINUE
C
      STOP
  100 FORMAT ('  A=',F4.1,'  B=',F4.1,'  M=',I5,
     *//,T5,'N',T16,'S',T27,'R',T39,'U',T51,'U/S'/)
  200 FORMAT (I5,D14.3,F9.1,2D14.3)
      END
