C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MEALGO                                                  +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE EALGO.                         +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINE   EALGO                                                  +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PROGRAM MEALGO 
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      INTEGER I, IER, INIT, K, M, MAXCOL, MPI, NBC
      DOUBLE PRECISION AKPI, EINIT, EPS, S, T
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (MAXCOL = 5, NBC = 20, EPS = 1.0D-30)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      DOUBLE PRECISION E(0:MAXCOL), G(MAXCOL*NBC), GINIT(2*MAXCOL)
C
C                        ... EXECUTABLE STATEMENTS
C
      WRITE (*,*) ' OUTPUT RESULTS FROM MEALGO'
      WRITE (*,*)
      INIT = 0
C
      DO 30 K = 1, NBC
C
C                        ... COMPUTATION OF S
C                                            K-1
C
         T     = DBLE(K)
         EINIT = 1.0D0/T
C
C                        ... COMPUTATION OF G  (K-1)
C                                            I
C
         M = MAX0(1,K-2)
         IF (K .GT. MAXCOL+1) M = MAXCOL
         DO 10 I = 1, M
            AKPI = DBLE(K + I)
            GINIT(I) = -1.0D0/(AKPI-1.0D0)/AKPI
   10    CONTINUE
         IF (K.GE.3 .AND. K.LE.MAXCOL+1) THEN
C
C                        ... COMPUTATION OF G  (I-1)
C                                            K-1
C
            DO 20 I = 1, K
               AKPI = DBLE(K + I)
               MPI  = M + I
               GINIT(MPI) = -1.0D0/(AKPI-2.0D0)/(AKPI-1.0D0)
   20       CONTINUE
         END IF
C
C                        ... CALL EALGO
C
         CALL EALGO (E, MAXCOL, INIT, EPS, EINIT, GINIT, G, IER)
C
         IF (IER .NE. 0) THEN
            WRITE (*,*) ' STOP DUE TO IER =',IER
            IF (IER.EQ.100) 
     *        WRITE (*,*) ' DIVISION BY ZERO IN THE SUBROUTINE EALGO'
            STOP
         END IF
C
         S = 1.0D0/T**2
         T = (DBLE(MAXCOL+1)*K)
         IF (K .GT. MAXCOL+1) S = 1.0D0/T
         I = MIN0(K,MAXCOL+1)
         WRITE (*,*) E(I-1), S
   30 CONTINUE
C
      STOP
      END
