C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MGTRAN                                                  +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE GTRAN.                         +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINE    GTRAN                                                 +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PROGRAM MGTRAN
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      INTEGER I, IER, INIT, MAXCOL, NBC
      DOUBLE PRECISION EPS, GINIT, RSINIT, TMP
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (MAXCOL=10, NBC=15, EPS=1.0D-30)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      DOUBLE PRECISION GVEC(0:2*MAXCOL-1), RSVEC(0:2*MAXCOL-2)
C
C                        ... EXECUTABLE STATEMENTS
C
      WRITE (*,*) ' OUTPUT RESULTS FROM MGTRAN'
      WRITE (*,100) ' ITERATION', ' GINIT INPUT', ' GINIT OUTPUT'
C
      INIT   = 0
C
      DO 10 I = 1, NBC
         GINIT  = 1.0D0/DBLE(I)
         RSINIT = 1.0D0/DBLE(I+1) - GINIT
         TMP    = GINIT
C
C                        ... CALL GTRAN
C
         CALL GTRAN (GVEC, MAXCOL, INIT, EPS, GINIT, RSINIT, 
     *      RSVEC, IER) 
C
         IF (IER .NE. 0) THEN
            WRITE (*,*) ' NON ZERO IER =',IER
            IF (IER.EQ.100) 
     *         WRITE (*,*) ' DIVISION BY ZERO IN THE SUBROUTINE GTRAN'
            IF (IER .EQ. 400) THEN
               WRITE (*,*) ' NUMERICAL INSTABILITY DETECTED'
               IER = 0
            ELSE 
               STOP
            END IF
         END IF
C
         WRITE (*,200) I, TMP, GINIT
   10 CONTINUE
      WRITE (*,*)
      WRITE (*,*) ' LAST GVEC VECTOR'
      WRITE (*,*)
      WRITE (*,*) (GVEC(I), I=0,2*MAXCOL-1)
C
  100 FORMAT (/T3,A,T27,A,T52,A/)
  200 FORMAT (I12,2D26.16)
      STOP
      END
