C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MHALGO                                                  +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE HALGO.                         +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINE   HALGO                                                  +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PROGRAM MHALGO 
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      INTEGER I, IER, INIT, IP, IR, J, K, M, MAXCOL, MPI, NBC
      DOUBLE PRECISION AKPI, EPS, SK
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (MAXCOL=5, NBC=20, IR=5, IP=3, EPS = 1.0D-30)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      DOUBLE PRECISION H(IR,0:MAXCOL), HINIT(IR), G(MAXCOL*NBC), 
     *          GINIT(2*MAXCOL)
C
C                        ... EXECUTABLE STATEMENTS
C
      WRITE (*,*) ' OUTPUT RESULTS FROM MHALGO'
      WRITE (*,*)
      INIT = 0
C
      DO 40 K = 1, NBC
C
C                        ... COMPUTATION OF S
C                                            K-1
         SK = 1.0D0/DBLE(K)
         DO 10 I = 1, IP
            HINIT(I) = SK**I
   10    CONTINUE
C
C                        ... COMPUTATION OF G  (K-1)
C                                            I
C
         M = MAX0(1,K-2)
         IF (K .GT. MAXCOL+1) M = MAXCOL
         DO 20 I=1,M
            AKPI = DBLE(K + I)
            GINIT(I) = -1.0D0/(AKPI-1.0D0)/AKPI
   20    CONTINUE
         IF (K.GE.3  .AND.  K.LE.MAXCOL+1) THEN
C
C                        ... COMPUTATION OF G  (I-1)
C                                            K-1
C
            DO 30 I = 1, K
               AKPI = DBLE(K + I)
               MPI  = M + I
               GINIT(MPI) = -1.0D0/(AKPI-2.0D0)/(AKPI-1.0D0)
   30       CONTINUE
         END IF
C
C                        ... CALL HALGO
C
         CALL HALGO (H, MAXCOL, INIT, EPS, HINIT, GINIT, IR,
     *   IP, G, IER)
C
C
         IF (IER .NE. 0) THEN
            WRITE (*,*) ' STOP DUE TO IER =',IER
            IF (IER.EQ.100) 
     *        WRITE (*,*) ' DIVISION BY ZERO IN THE SUBROUTINE HALGO'
            STOP
         END IF
C
	 I = MIN0(K,MAXCOL+1)
	 WRITE (*,*) (H(J,I-1),J=1,IP)
   40 CONTINUE
      STOP
      END
