C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MOMEGA                                                  +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE OMEGA.                         +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINE    OMEGA                                                 +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PROGRAM MOMEGA
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      INTEGER I, IER, INIT, J, MAXC, MAXCOL, NBC
      DOUBLE PRECISION EPS, OMEINI 
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (MAXCOL=5, NBC=15, EPS=1.0D-30)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      DOUBLE PRECISION OMEVEC(0:MAXCOL-1), S(NBC)
C
C                        ... EXECUTABLE STATEMENTS
C
      WRITE (*,*) ' OUTPUT RESULTS FROM MOMEGA'
      WRITE (*,100) ' ITERATION', 'OMEINI INPUT', 'OMEINI OUTPUT'
C
      DO 10 I = 1, NBC
         S(I) = 1.0D0/DBLE(I)
   10 CONTINUE
C
      INIT   = 0
      MAXC   = MAXCOL
C
      DO 30 I = 1, NBC
         OMEINI = S(1)
C
C                        ... CALL OMEGA
C
         CALL OMEGA (OMEVEC, MAXC, INIT, EPS, OMEINI, IER) 
C
         IF (IER .NE. 0) THEN
            WRITE (*,*) ' STOP DUE TO IER =',IER
            IF (IER.EQ.100) 
     *        WRITE (*,*) ' DIVISION BY ZERO IN THE SUBROUTINE OMEGA'
            STOP
         END IF
C
         WRITE (*,200) I, S(1), OMEINI
         IF (I .NE. NBC) THEN
            DO 20 J = 1, NBC - I 
               S(J) = S(J+1) - S(J)
   20       CONTINUE
         END IF
   30 CONTINUE
      WRITE (*,*)
      WRITE (*,*) ' LAST OMEVEC VECTOR'
      WRITE (*,*)
      WRITE (*,*) (OMEVEC(I), I=0,MAXC)
C
  100 FORMAT (/T3,A,T27,A,T52,A/)
  200 FORMAT (I12,2D26.16)
      STOP
      END
