C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MRICHAR                                                 +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE RICHAR.                        +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINE    RICHAR                                                +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PROGRAM MRICHAR
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      INTEGER I, IER, INIT, MAXCOL, NBC
      DOUBLE PRECISION EPS, XINIT, TX, TINIT
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (MAXCOL=5, NBC=10, EPS=1.0D-30)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      DOUBLE PRECISION T(0:MAXCOL), XAUX(0:MAXCOL)
C
C                        ... EXECUTABLE STATEMENTS
C
      WRITE (*,*) ' OUTPUT RESULTS FROM MRICHAR'
      WRITE (*,100) ' ITER.', 'XINIT INPUT', 'TINIT INPUT', 
     *              'TINIT OUTPUT'
      INIT = 0
C
      DO 10 I = 1, NBC
         XINIT = 1.0D0/DBLE(I)
	 TX    = XINIT**5
         TINIT = TX
C
C                        ... CALL RICHAR
C
         CALL RICHAR (T, MAXCOL, INIT, EPS, TINIT, XAUX, XINIT, IER)
C
         IF (IER .NE. 0) THEN
            WRITE (*,*) ' STOP DUE TO IER =',IER
            IF (IER.EQ.100) 
     *        WRITE (*,*) ' DIVISION BY ZERO IN THE SUBROUTINE RICHAR'
            STOP
         END IF
C
         WRITE (*,200) I, XINIT, TX, TINIT
   10 CONTINUE
      WRITE (*,*)
      WRITE (*,*) ' LAST T VECTOR'
      WRITE (*,*)
      WRITE (*,*) (T(I), I=0,MAXCOL)
C
  100 FORMAT (/T2,A,T19,A,T42,A,T64,A/)
  200 FORMAT (I6,3D23.15)
      STOP
      END
