C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MRSALGO                                                 +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE RSALGO.                        +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINE    RSALGO                                                +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PROGRAM MRSALGO
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      INTEGER I, IER, IFLAG, INIT, MAXCOL, NBC
      DOUBLE PRECISION A, EPS, RSINIT, TMP
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (MAXCOL=5, NBC=15, EPS=1.0D-30, IFLAG=0)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      DOUBLE PRECISION RSVEC(0:2*MAXCOL-2)
C
C                        ... EXECUTABLE STATEMENTS
C
      WRITE (*,*) ' OUTPUT RESULTS FROM MRSALGO'
      WRITE (*,100) ' ITERATION', 'RSINIT INPUT', 'RSINIT OUTPUT'
C
      INIT   = 0
      A      = -1.0D0
C
      DO 10 I = 1, NBC
         A      = -A
         RSINIT = A*20.5D0*I - 17.5D0 * (I+1)
         TMP    = RSINIT
C
C                        ... CALL RSALGO
C
         CALL RSALGO (RSVEC, MAXCOL, INIT, EPS, RSINIT, IFLAG, IER) 
C
         IF (IER .NE. 0) THEN
            WRITE (*,*) ' NON ZERO IER =',IER
            IF (IER.EQ.100) 
     *         WRITE (*,*) ' DIVISION BY ZERO IN THE SUBROUTINE RSALGO'
            IF (IER .EQ. 400) THEN
               WRITE (*,*) ' NUMERICAL INSTABILITY DETECTED'
               IER = 0
            ELSE 
               STOP
            END IF
         END IF
C
         WRITE (*,200) I, TMP, RSINIT
   10 CONTINUE
      WRITE (*,*)
      WRITE (*,*) ' LAST RSVEC VECTOR'
      WRITE (*,*)
      WRITE (*,*) (RSVEC(I), I=0,2*MAXCOL-2)
C
  100 FORMAT (/T3,A,T27,A,T52,A/)
  200 FORMAT (I12,2D26.16)
      STOP
      END
