C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MSEALGO                                                 +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE SEALGO.                        +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINE   SEALGO                                                 +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PROGRAM MSEALGO 
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      INTEGER I, IER, INIT, IP, IR, J, K, M, MAXCOL, MPI, NBC
      DOUBLE PRECISION AKPI, EPS, SK
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (MAXCOL=5, NBC=20, IR=5, IP=3, EPS=1.0D-30)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      INTEGER IZERO(IR)
      DOUBLE PRECISION E(IR,0:MAXCOL), EINIT(IR), GINIT(IR,2*MAXCOL),
     *  G(IR,MAXCOL*NBC)
C
C                        ... EXECUTABLE STATEMENTS
C
      WRITE (*,*) ' OUTPUT RESULTS FROM MSEALGO'
      WRITE (*,*)
      INIT = 0
C
      DO 60 K = 1, NBC
C
C                        ... COMPUTATION OF S
C                                            K-1
C
	 SK = 1.0D0/DBLE(K)
         DO 10 I = 1, IP
            EINIT(I) = SK**I
   10    CONTINUE
C
C                        ... COMPUTATION OF G  (K-1)
C                                            I
C
         M = MAX0(1,K-2)
         IF (K .GT. MAXCOL+1) M = MAXCOL
         DO 30 I = 1, M
	    AKPI = DBLE(K + I)
	    DO 20 J = 1, IP
	       GINIT(J,I) = -1.0D0/(AKPI-1.0D0)/AKPI
   20       CONTINUE
   30    CONTINUE
         IF (K.GE.3 .AND. K.LE.MAXCOL+1) THEN
C
C                        ... COMPUTATION OF G  (I-1)
C                                            K-1
C
            DO 50 I = 1, K
               AKPI = DBLE(K + I)
               MPI  = M + I
               DO 40 J = 1, IP
	          GINIT(J,MPI) = -1.0D0/(AKPI-2.0D0)/(AKPI-1.0D0)
   40          CONTINUE
   50       CONTINUE
         END IF
C
C                        ... CALL SEALGO
C
         CALL SEALGO (E, MAXCOL, INIT, EPS, EINIT, GINIT, IR,
     *   IP, G, IZERO, IER)
         IF (IER .NE. 0) THEN
            WRITE (*,*) ' NON ZERO IER =',IER
            IF (IER .EQ. 100) THEN
              WRITE (*,*) ' DIVISION BY ZERO IN THE SUBROUTINE SEALGO'
              WRITE (*,*) ' IZERO VECTOR', (IZERO(I),I=1,IP)
              IER = 0
            ELSE
              STOP
            END IF
         END IF
C
	 I = MIN0(K,MAXCOL+1)
	 WRITE (*,*) (E(J,I-1),J=1,IP)
   60 CONTINUE
C
      STOP
      END
