C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MSELECT                                                 +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE SELECT.                        +
C           THIS MAIN ALSO SHOWS HOW TO INCREASE THE WORKING SPACE THROUGH     +
C           THE SUBROUTINE INCSTO.                                             +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINES  ARRSTO, EPSRHA, IDELTA, INCSTO, LEVINT, OVERHO,        +
C                       RICHAR, SELECT, THETA                                  +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PROGRAM MSELECT
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      INTEGER I, INIT, N, NBC, NDIGIT, NTR
      INTEGER*4 IDIM, MAXASZ
      DOUBLE PRECISION A, AERR, EPS, SINIT, SLIMIT
      CHARACTER*1 CT
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (NTR=9, NBC=20, EPS=1.0D-30, NDIGIT=12, MAXASZ=2000)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      INTEGER IER(NTR+2), IOR(NTR), ITOR(NTR)
      DOUBLE PRECISION ANDIG(0:NTR), REST(NTR)
      DOUBLE PRECISION AWRK(MAXASZ)
C
C                        ... COMMON STATEMENTS
C      
      COMMON /WRKSPR/ AWRK
C
C                        ... DATA STATEMENTS
C
      DATA CT /'T'/
C
C                        ... EXECUTABLE STATEMENTS
C
C                        ... INCREASE THE WORKING VECTOR DIMENSION
C
      IDIM = MAXASZ
      CALL INCSTO (IDIM)
C
      WRITE (*,*) ' OUTPUT RESULTS FROM MSELECT',
     *            ' (NUMBER OF SIGNIFICANT DIGITS)'
C
      A  =  3.0D0
C
C                        ... DEFINE THE LIMIT S
C
      SLIMIT = 0.0D0
C
      INIT = 0
      DO 30 N = 1, NBC 
C
C                        ... COMPUTATION OF S
C                                            N
C
         SINIT = DSIN(A*N)/DBLE(N)
C
C                        ... CALL SELECT
C
         CALL SELECT (NBC, INIT, EPS, SINIT, ITOR, REST, NDIGIT, IER)
C
         IF (IER(11) .NE. 0) THEN
            WRITE (*,*) ' STOP DUE TO IER =',IER(11)
            IF (IER(11) .EQ. 1000) THEN
               WRITE (*,200) 'IER',' ', (CT,I=1,NTR)
               WRITE (*,300) ' ', (I,I=1,NTR)
               WRITE (*,*)
               WRITE (*,300) ' ', (IER(I),I=1,NTR)
            END IF
            STOP
         END IF
C
         IF (N .EQ. 1) THEN
         WRITE (*,200) 'IT.', 'S', (CT,I=1,NTR)
         WRITE (*,300) ' ', (I,I=1,NTR)
         END IF
C
         IF (N .GE. 3) THEN
C
C                        ... COMPUTE THE RELATIVE ERROR FOR S
C                                                            N
C
            AERR = DABS(SINIT-SLIMIT)
            IF (DABS(SLIMIT) .NE. 0.0D0) AERR = AERR/DABS(SLIMIT)
            IF (AERR .EQ. 0.0D0) THEN
               ANDIG(0) = 99.0D0
            ELSE
               ANDIG(0) = -DLOG10(AERR)
            END IF
C
C                        ... COMPUTE THE RELATIVE ERROR FOR THE RESULTS
C                            OF THE TRANSFORMATIONS USED
C
            DO 10 I = 1, NTR
               AERR = DABS(REST(I)-SLIMIT)
               IF (DABS(SLIMIT) .NE. 0.0D0) AERR = AERR/DABS(SLIMIT)
               IF (AERR .EQ. 0.0D0) THEN
                  ANDIG(I) = 99.0D0
               ELSE
                  ANDIG(I) = -DLOG10(AERR)
               END IF
   10       CONTINUE
            WRITE (*,400) N, (ANDIG(I),I=0,NTR)
C
C                        ... COMPUTE THE ORDER OF THE TRANSFORMATIONS
C
            DO 20 I = 1, NTR
               IOR(ITOR(I)) = I
   20       CONTINUE
            WRITE (*,300) 'ORDER', (IOR(I),I=1,NTR)
            WRITE (*,100) 'SELECT', (CT,I=1,NTR)
            WRITE (*,600) (ITOR(I),I=1,NTR)
         END IF
   30 CONTINUE
C
      STOP
  100 FORMAT(T3,A,T9,9A3)
  200 FORMAT(/T3,A,T9,A,T15,A,T22,A,T29,A,T36,A,T43,A,T50,A,T57,A,
     *       T64,A,T71,A)
  300 FORMAT(T3,A,T10,9I7)
  400 FORMAT(/I4,10F7.2)
  500 FORMAT(T3,A,T12,9F7.2)
  600 FORMAT(T10,9I3)
      END
