C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MVEALGO                                                 +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE VEALGO.                        +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINE                 VEALGO                                   +
C       -  DOUBLE PRECISION FUNCTION  INNERP                                   +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PROGRAM MVEALGO 
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      INTEGER I, IER, INIT, IP, IR, J, K, M, MAXCOL, MPI, NBC
      DOUBLE PRECISION AKPI, EPS, SK
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (MAXCOL=5, NBC=20, IR=5, IP=3, EPS=1.0D-30)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      DOUBLE PRECISION E(IR,0:MAXCOL), EINIT(IR), GINIT(IR,2*MAXCOL),
     *  Y(IR), G(IR,MAXCOL*NBC), WG(IR)
C
C                        ... EXECUTABLE STATEMENTS
C
      WRITE (*,*) ' OUTPUT RESULTS FROM MVEALGO'
      WRITE (*,*)
      INIT = 0
      DO 10 I = 1, IP
	 Y(I) = 1.0D0
   10 CONTINUE
C
      DO 70 K = 1, NBC
C
C                        ... COMPUTATION OF S
C                                            K-1
C
	 SK = 1.0D0/DBLE(K)
	 DO 20 I = 1, IP
            EINIT(I) = SK**I
   20    CONTINUE
C
C                        ... COMPUTATION OF G  (K-1)
C                                            I
C
         M = MAX0(1,K-2)
         IF (K .GT. MAXCOL+1) M = MAXCOL
         DO 40 I = 1, M
	    AKPI = DBLE(K + I)
	    DO 30 J = 1, IP 
               GINIT(J,I) = -1.0D0/(AKPI-1.0D0)/AKPI
   30       CONTINUE
   40    CONTINUE 
         IF (K.GE.3 .AND. K.LE.MAXCOL+1) THEN
C
C                        ... COMPUTATION OF G  (I-1)
C                                            K-1
C
            DO 60 I = 1, K
               AKPI = DBLE(K + I)
               MPI  = M + I
               DO 50 J = 1, IP
                  GINIT(J,MPI) = -1.0D0/(AKPI-2.0D0)/(AKPI-1.0D0)
   50          CONTINUE
   60       CONTINUE
         END IF
C
C                        ... CALL VEALGO
C
         CALL VEALGO (E, MAXCOL, INIT, EPS, EINIT, GINIT, Y,
     *   IR, IP, G, WG, IER)
C
         IF (IER .NE. 0) THEN
            WRITE (*,*) ' STOP DUE TO IER =',IER
            IF (IER.EQ.100) 
     *        WRITE (*,*) ' DIVISION BY ZERO IN THE SUBROUTINE VEALGO'
            STOP
         END IF
C
	 I = MIN0(K,MAXCOL+1)
	 WRITE (*,*) (E(J,I-1),J=1,IP)
   70 CONTINUE
      STOP
      END
