C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   PROGRAM NAME     - MVGTRAN                                                 +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C                                                                              +
C   DESCRIPTION:                                                               +
C                                                                              +
C           MAIN PROGRAM TO TEST THE SUBROUTINE VGTRAN.                        +
C                                                                              +
C   MODULES REQUIRED:                                                          +
C                                                                              +
C       -  SUBROUTINE                 VGTRAN                                   +
C       -  DOUBLE PRECISION FUNCTION  ENORM2                                   +
C                                                                              +
C+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
C
      PROGRAM MVGTRAN
C
C                        ... SPECIFICATIONS FOR VARIABLES AND CONSTANTS
C
      INTEGER I, II, IER, INIT, IP, IR, J, MAXCOL, NBC
      DOUBLE PRECISION EN, EPS, RSINIT
C
C                        ... SPECIFICATIONS FOR PARAMETER CONSTANTS
C
      PARAMETER (MAXCOL=7, NBC=7, IR=5, IP=3, EPS=1.0D-30)
C
C                        ... SPECIFICATIONS FOR VECTORS AND MATRICES
C
      DOUBLE PRECISION GMAT(IR,0:2*MAXCOL-1), GINIT(IR), GAUX(IR),
     *                 RSVEC(0:2*MAXCOL-2), S(3,IR)
C
C                        ... SPECIFICATIONS FOR EXTERNAL FUNCTIONS
C
      DOUBLE PRECISION ENORM2
C
C                        ... DATA STATEMENTS
C
      DATA S / 2*1.0D0, 0.0D0, 
     *         0.0D0, 2.0D0, 0.0D0,
     *         0.0D0, 1.0D0, 0.0D0,
     *         6*0.0D0 /
C
C                        ... EXECUTABLE STATEMENTS
C
      WRITE (*,*) ' OUTPUT RESULTS FROM MVGTRAN'
      WRITE (*,100) ' IT.', 'GINIT INPUT', 'GINIT OUTPUT', 'NORM'
C
      INIT   = 0
C
      DO 60 I = 1, NBC
         DO 10 II = 1, IP
            GINIT(II) = S(1,II)
   10    CONTINUE
         RSINIT = 0.0D0
         DO 20 II = 1, IP
            RSINIT = RSINIT + S(2,II) - S(1,II)
   20    CONTINUE
C
C                        ... CALL VGTRAN
C
         CALL VGTRAN (GMAT, MAXCOL, INIT, EPS, GINIT, RSINIT, 
     *        RSVEC, GAUX, IR, IP, IER) 
C
         IF (IER .NE. 0) THEN
            WRITE (*,*) ' NON ZERO IER =',IER
            IF (IER.EQ.100) 
     *         WRITE (*,*) ' DIVISION BY ZERO IN THE SUBROUTINE VGTRAN'
            IF (IER .EQ. 400) THEN
               WRITE (*,*) ' NUMERICAL INSTABILITY DETECTED'
               IER = 0
            ELSE 
               STOP
            END IF
         END IF
C
         EN = ENORM2(GINIT, 1, IR, IP)
         WRITE (*,200) I, S(1,1), GINIT(1), EN
         DO 30 II= 2, IP
            WRITE (*,300) S(1,II), GINIT(II)
   30    CONTINUE
C
         DO 40 II= 1, IP
            S(3,II) = S(1,II)*0.5D0
   40    CONTINUE
         DO 50 J = 1, 2
            DO 50 II = 1, IP
               S(J,II) = S(J+1,II)
   50    CONTINUE
C
   60 CONTINUE
C
      STOP
  100 FORMAT (/T2,A,T20,A,T43,A,T75,A)
  200 FORMAT (/I4,(T7,3D24.16))
  300 FORMAT (T7,2D24.16)
      END
